<!doctype html>
<meta charset="UTF-8">
<html>
  <head>
    <title>Socket.IO chat</title>
    <style>
      * { margin: 0; padding: 0; box-sizing: border-box;}
      body { font: 13px Helvetica, Arial; height: 100%; background-color: rgb(251, 253, 253);}
      form { background: #000; padding: 3px; width: auto; border:1px solid red; }
      form input { border: 0; padding: 10px; width: 90%; margin-right: .5%; height:5%; }
      form button { width: 9%; background: rgb(130, 224, 255); border: none; padding: 10px;height:5%; }
      .container{
        height: 100%;
        max-width: 950px;
        margin: auto;
        border: solid 50px rgb(192, 60, 60);
        border-radius: 10px;
        overflow: hidden;
        position: absolute;
        top: 0; left: 0; bottom: 0; right: 0;  
      }
      .chat-container{
        height: 95%;
        position:relative;
        overflow: auto;
        transform: rotate(180deg);
        direction: rtl;
        background-color: rgb(86, 156, 121);
      }  
      .messages{
        border-bottom: solid 1px #ccc;
        padding: 20px;
        transform: rotate(180deg);
        direction: ltr;
        background-color: rgb(86, 156, 121);

      }
      .connected{
        width: 30%;
        height: 95%;
        padding: 0px;
        text-align: center;
        font-size: 13px;
        float:right;
        word-wrap: break-word;
        background-color: grey;        
      }

    </style>
  </head>
  <body>

    <div class="container">
      <div class="connected">
        <h1>Connected Users:</h1>
        <p></p>
      </div>
      <div class="chat-container">
        <div class="messages">
          <p></p>
        </div>
      </div>
      
      <form action="">
        <input id="m" autocomplete="off" /><button>Send</button>
      </form>
    </div>
    <script src="https://cdn.socket.io/socket.io-1.2.0.js"></script>
    <script src="https://code.jquery.com/jquery-1.11.1.js"></script>
    <script> src=$(function () {
      var socket = io();

      //intake chat messages
      $('form').submit(function(){
        socket.emit('chat message', $('#m').val());
        $('#m').val('');
        return false;
      });

      //print chat messages
      socket.on('chat message', ({msg,userColor})=>{
        var message = $('.messages').first().clone();
        message.find('p').text(msg);
        message.css("font-weight", "normal");
        message.css("color", userColor);
        message.prependTo('.chat-container');
        $(".chat-container").scrollTop(0);
      });

      //print local chat messages
      socket.on('local chat message', ({msg,userColor})=>{
        var message = $('.messages').first().clone();
        message.find('p').text(msg);
        message.css("font-weight", "bold");
        message.css("color", userColor);
        message.prependTo('.chat-container');
        $(".chat-container").scrollTop(0);
      });

      //confirm colour change locally
      socket.on('colour change', function(ChosenColour){
        var message = $('.messages').first().clone();
        message.find('p').text("Colour changed");
        ChosenColour = "#" + ChosenColour;
        message.css("color", ChosenColour);
        message.prependTo('.chat-container');
        $(".chat-container").scrollTop(0);
      });

      //confirm username change locally
      socket.on('username change', ({ChosenName,userColor})=>{
        var message = $('.messages').first().clone();
        message.find('p').text("Username changed to " + ChosenName);
        message.css("color", userColor);
        message.prependTo('.chat-container');
        $(".chat-container").scrollTop(0);
      });
      //reject username change locally
      socket.on('username change fail', ({ChosenName,userColor})=>{
        var message = $('.messages').first().clone();
        message.find('p').text("Username already taken");
        message.css("color", userColor);
        message.prependTo('.chat-container');
        $(".chat-container").scrollTop(0);
      });

      //print local info to a new user joining so that they get message history and their username
      socket.on('newLocalUser', ({Local,messageHist,setColor})=>{
        $.each(messageHist, function(index) {
          var message = $('.messages').first().clone();
          message.find('p').text(messageHist[index]);
          message.css("font-weight", "normal");
          message.css("color", setColor[index]);
          message.prependTo('.chat-container');
          window.scrollTo(0, document.body.scrollHeight);
          });
        
          var message = $('.messages').first().clone();
          message.find('p').text("You are " + Local);
          message.css("font-weight", "normal");
          message.css("color", "#000000");
          message.prependTo('.chat-container');
          window.scrollTo(0, document.body.scrollHeight);
      });
            
      //print user connection string
      socket.on('newUser', function(UserJoined){
        var message = $('.messages').first().clone();
        UserJoined = UserJoined + " Connected";
        message.find('p').text(UserJoined);
        message.css("font-weight", "normal");
        message.prependTo('.chat-container');
        window.scrollTo(0, document.body.scrollHeight);
      });

      //track connecting users
      socket.on('newUserConnection', function(usernamesInUse){
        $( "p" ).remove( ":contains('Username:')" );
        $.each(usernamesInUse, function(index) {
          var output = $( "<p id=con></p>" ).text("Username:"+usernamesInUse[index]);
          $(".connected").append(output);
          });
        });

      //notify other users of a user disconnecting
      socket.on('removeUser', function(UserLeft){
        var message = $('.messages').first().clone();
        UserLeft = UserLeft + " Disconnected"
        message.find('p').text(UserLeft);
        message.css("font-weight", "normal");
        message.prependTo('.chat-container');
        window.scrollTo(0, document.body.scrollHeight);
      });

      //track disconnecting users
      socket.on('removeUserConnection', function(usernamesInUse){
        $( "p" ).remove( ":contains('Username:')" );
        $.each(usernamesInUse, function(index) {
          var output = $( "<p id=con></p>" ).text("Username:"+usernamesInUse[index]);
          $(".connected").append(output);
          });
        });
    });</script>
  </body>
</html>
